<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticssobi2 extends JPlugin
{
	function plgAnalyticssobi2( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onGetChartTypes(&$data, $name) {
		
		if($name != 'sobi2') return;
		
		$data = array('amline', 'ampie', 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
			
		if($name != 'sobi2') return;

		global $mainframe;

		$type = $params->get('chart_type');

		if( !JComponentHelper::isEnabled('com_sobi2', true) ) {
			$errors = '<h3>SOBI2 Component Not Exists or Not Enabled<h3>';
			return;
		}
		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		if( $type == 'ampie' ){
			$objChart->addLabel("<![CDATA[This graph shows Content categories records relationship]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Categories records relationship</b>]]>",15 ,25 , array('text_size' => 16));
		}else{
			$objChart->addLabel("<![CDATA[This graph shows Content categories records progress]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Categories records progress</b>]]>",90 ,25 , array('text_size' => 16));
		}
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'sobi2' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc	= JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}
		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}
		$form .= '</table>';
	}

	function onChartData( &$objChart, $name, $params )
	{
		if($name != 'sobi2') return;

		$type = $params->get('chart_type');

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$category = $params->get( 'category' );
		$from    = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to      = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby  = $params->get( 'groupby', 'smonth' );

		if( !$category ) return;

		if( !is_array( $category ) ) {
			$category = array( $category );
		}
		
		if ($type != 'ampie') {
			$group_index = Array ("sday" => "DAYOFYEAR(i.publish_up)", 
								  "sweek" => "WEEKOFYEAR(i.publish_up)", 
								  "smonth" => "MONTH(i.publish_up)", 
								  "syear" => "YEAR(i.publish_up)" );
			
			$date_index = Array ("sday" => "DATE_FORMAT( i.publish_up, '%Y-%m-%d' )", 
								 "sweek" => "DATE_FORMAT( i.publish_up - INTERVAL WEEKDAY(i.publish_up) DAY, '%Y-%m-%d' )", 
								 "smonth" => "DATE_FORMAT( i.publish_up, '%Y-%m-01' )", 
								 "syear" => "DATE_FORMAT( i.publish_up, '%Y-01-01' )" );
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(i.publish_up) AS c_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'c_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
		}

		$sql = "    SELECT  Count(i.itemid) AS amount, cats.name , cats.catid AS id"
		.$sql_dates
		."\n FROM #__sobi2_categories AS cats
		Inner Join #__sobi2_cat_items_relations AS rel ON rel.catid = cats.catid
		Inner Join #__sobi2_item AS i ON i.itemid = rel.itemid "
		."\n     WHERE i.published = 1 AND cats.catid IN ('".implode( "', '", $category )."') AND i.publish_up BETWEEN '".$from."' AND '".$to."'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND i.owner = '$user_id'";
		$sql .= "  GROUP BY ".$sql_group." cats.catid";

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;
		
		if( $type != 'ampie' ){
			
			$current_date = $from;
	
			switch ( $groupby ) {
				case "sday":
					$format_series 		= '%Y %d %b';
					break;
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
					$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %UW';
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %b';
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y';
					break;
			}
			
			foreach ( $result AS $row ) {
				$graphs[$row->name][$row->date_index] = $row->amount;
			}
			while ( strtotime( $current_date ) <= strtotime( $to ) ) {
				$serie = strftime( $format_series, strtotime( $current_date ) );
				$objChart->addSerie($current_date,$serie);
				if ( $type == 'amline')
				{
					foreach( $graphs as $key => $graph) {
						if( !isset($graphs[$key][$current_date]) ) {
							$graphs[$key][$current_date] = " 0 ";
						}
					}
				}
				$current_date = $this->incrementDate( $current_date, $groupby );
			}
			
			foreach( $graphs as $key => $graph ) {
				$objChart->addGraph($key, $key, $graph, array( 
					'balloon_text' => '<![CDATA[<b>{value}</b> {series}]]>'
				));
			} 
		} else {
			
			foreach ( $result AS $row ) {
				$slices[$row->name] = $row->amount;
			}
	
			$i = 0;
			foreach ( $slices AS $k => $slice ) {
	
				$pulout = $i == 0 ? 'true' : 'false';
				$objChart->addSlice($k, $slice, array( 'pull_out' => $pulout, 'alpha' => 95) );
				$i++;
			}
		}
		
	/*	foreach ( $result AS $row ) {
			$graphs[$row->id]["name"] = $row->name;
			$graphs[$row->id]["values"][$row->date_index] = "<value xid='".$row->date_index."'>{$row->amount}</value>";
		}

		$current_date = $from;

		switch ( $groupby ) {
			case "sweek" :
				$timestamp = strtotime( $current_date );
				$date_info = getdate($timestamp);

				$timestamp -= ($date_info['wday'] == 0 ? 7 : $date_info['wday'] -1 )*60*60*24;
				$current_date = date ( "Y-m-d", $timestamp );
				break;
			case "smonth" :
				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
				$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
				$current_date = date ( "Y-m-d", $timestamp );
				break;
			case "syear" :
				preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
				$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
				$current_date = date ( "Y-m-d", $timestamp );
				break;
		}

		while ( strtotime( $current_date ) <= strtotime( $to ) ) {

			$series[] = "<value xid='{$current_date}'>".$current_date."</value>";

			foreach( $graphs as $key => $graph) {
				if( !isset($graphs[$key]['values'][$current_date]) ) {
					$graphs[$key]['values'][$current_date] = "<value xid='".$current_date."'>0</value>";
				}
			}

			switch ( $groupby ) {
				case "sday" :
					$timestamp = strtotime( $current_date );
					$timestamp += 60*60*24;
					break;
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$timestamp += 60*60*24*7;
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$m[2]++;
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$m[1]++;
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					break;
			}
			$current_date = date ( "Y-m-d", $timestamp );
		}*/

/*		$out = "<chart>";

		$out .= "<series>";
		$out .= implode("", $series);
		$out .= "</series>";

		$out .= "<graphs>";

		foreach( $graphs as $key => $graph ) {
			$out .= "<graph gid='".md5( $key )."' title='".$graphs[$key]["name"]."' bullet='round' bullet_size='8' line_width='2'>";
			$out .= implode( "", $graph['values'] );
			$out .= "</graph>";
		}

		$out .= "</graphs>";

		$out .= "</chart>";

		$data = $out;*/

	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'sobi2') return;

		$type = $params->get('chart_type');
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');
		
		$category = $params->get( 'category' );
		$from    = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to      = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby  = $params->get( 'groupby', 'smonth' );
		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);
		
		if( !$category ) return;

		if( !is_array( $category ) ) {
			$category = array( $category );
		}
		
		if ($type != 'ampie') {
			$group_index = Array ("sday" => "DAYOFYEAR(i.publish_up)", 
								  "sweek" => "WEEKOFYEAR(i.publish_up)", 
								  "smonth" => "MONTH(i.publish_up)", 
								  "syear" => "YEAR(i.publish_up)" );
			
			$date_index = Array ("sday" => "DATE_FORMAT( i.publish_up, '%Y-%m-%d' )", 
								 "sweek" => "DATE_FORMAT( i.publish_up - INTERVAL WEEKDAY(i.publish_up) DAY, '%Y-%m-%d' )", 
								 "smonth" => "DATE_FORMAT( i.publish_up, '%Y-%m-01' )", 
								 "syear" => "DATE_FORMAT( i.publish_up, '%Y-01-01' )" );
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(i.publish_up) AS c_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'c_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
		}
		
		$sql = "    SELECT  Count(i.itemid) AS amount, cats.name , cats.catid AS id"
		.$sql_dates
		."\n FROM #__sobi2_categories AS cats
		Inner Join #__sobi2_cat_items_relations AS rel ON rel.catid = cats.catid
		Inner Join #__sobi2_item AS i ON i.itemid = rel.itemid "
		."\n     WHERE i.published = 1 AND cats.catid IN ('".implode( "', '", $category )."') AND i.publish_up BETWEEN '".$from."' AND '".$to."'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND i.owner = '$user_id'";
		$sql .= "  GROUP BY ".$sql_group." cats.catid";
		$sql .= " ORDER BY ".($sort_by ? $sort_by : 'amount DESC') ;
		if($limit)
			$sql .= " LIMIT 0, $limit";

		$db->setQuery( $sql ); 
		$result = $db->loadObjectList();
	
		if( !$result) return;
			
		if ( $type != 'ampie')
		{
			foreach ( $result AS $row ) {
				$graphs[$row->id]["name"] = $row->name;
				$graphs[$row->id]["values"][$row->date_index] = $row->amount;
			}
	
			$k     = 0;
			$total = 0;
	
			$out[] = '<table class="adminlist" cellspacing="0">';
			$out[] = '<thead>';
			$out[] = '<tr>';
			$out[] = '<th width="1%">#</th>';
			foreach( $graphs as $key => $graph) {
				$out[] = '<th class="title">'.$graph['name'].'</th>';
			}
			$out[] = '<th width="1%">'.JText::_('Date').'</th>';
			$out[] = '</tr>';
			$out[] = '</thead>';
			$out[] = '<tbody>';
	
			$current_date = $from;
	
			switch ( $groupby ) {
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
					$timestamp -= ($date_info['wday'] == 0 ? 7 : $date_info['wday'] -1 )*60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					break;
			}
	
			$i = 0;
			while ( strtotime( $current_date ) <= strtotime( $to ) ) {
				$i++;
				if ( $limit && $i > $limit ) break;
				$k = 1 - $k;
				$out[] = "<tr class='row".$k."'>";
				$out[] = "<td>".$i."</td>";
				foreach( $graphs as $key => $graph) {
					if( !isset($graphs[$key]['values'][$current_date]) ) {
						$graphs[$key]['values'][$current_date] = '<font color="#ccc">0</font>';
					}
					if( !isset($graphs[$key]['total']) ){
						$graphs[$key]['total'] = 0;
					}
	
					$graphs[$key]['total'] += $graphs[$key]['values'][$current_date];
					$out[] = "<td>".$graphs[$key]['values'][$current_date]."</td>";
	
				}
	
				$out[] = "<td>".$current_date."</td>";
				$out[] = "</tr>";
	
				$current_date = $this->incrementDate( $current_date, $groupby );
			}
	
			$out[] = "<tr class='row".$k."'><td><big><b>".JText::_('Total')."</b></big></td>";
			$current_total = 0;
			foreach( $graphs as $key => $graph) {
				$out[] = "<td><big><b>".$graph['total']."<b></big></td>";
				$current_total += $graph['total'];
			}
			$out[] = "<td></td></tr>";
		} else {
			$k                  = 0;
			$current_total      = 0;
	
			$out[] = '<table class="adminlist" cellspacing="0">';
			$out[] = '<thead>';
			$out[] = '<tr>';
			$out[] = '<th width="1%">#</th>';
			$out[] = '<th class="title">'.JText::_('Value').'</th>';
			$out[] = '<th width="1%">'.JText::_('Records').'</th>';
			$out[] = '</tr>';
			$out[] = '</thead>';
			$out[] = '<tbody>';
	
			foreach ( $result AS $row ) {
				$slices[$row->name] = $row->amount;
			}
	
			$k = 1;
			$i = 1;
			foreach ( $slices AS $p => $slice )
			{
				$current_total += $slice;
				$k = 1 - $k;
				$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>",
				$k, $i, $p, $slice);
				$i++;
			}
			$out[] = sprintf( "<tr class='row%d'><td></td><td nowrap><big><b>%s</b></big></td><td align='right'><big><b>%s</b></big></td></tr>",
				0, JText::_('Total'), $current_total );
		}

		$out[] = '</tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}
	
	function onGetTotals($name, $params)
	{
		if($name != 'sobi2') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$category = $params->get( 'category' );
		$from    = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to      = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );

		if( !$category ) return;

		if( !is_array( $category ) ) {
			$category = array( $category );
		}
		
		$sql = "    SELECT  Count(distinct i.itemid) AS amount "
		."\n FROM #__sobi2_categories AS cats
		Inner Join #__sobi2_cat_items_relations AS rel ON rel.catid = cats.catid
		Inner Join #__sobi2_item AS i ON i.itemid = rel.itemid "
		."\n     WHERE i.published = 1 AND cats.catid IN ('".implode( "', '", $category )."') AND i.publish_up BETWEEN '".$from."' AND '".$to."'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND i.owner = '$user_id'";

		$db->setQuery( $sql ); 
		$result = $db->loadResult();

		$sql2 = "    SELECT  Count(distinct i.itemid) AS amount "
		."\n FROM #__sobi2_categories AS cats
		Inner Join #__sobi2_cat_items_relations AS rel ON rel.catid = cats.catid
		Inner Join #__sobi2_item AS i ON i.itemid = rel.itemid "
		."\n     WHERE i.published = 1 AND cats.catid IN ('".implode( "', '", $category )."')";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql2 .= " AND i.owner = '$user_id'";
			
		$db->setQuery( $sql2 );
		$dbtotal_records = $db->loadResult();
		
		$sql = 'SELECT count(cats.catid) as amount '
		.'FROM #__sobi2_categories AS cats '
		.'WHERE cats.published = 1 ';
		
		$db->setQuery( $sql );
		$total = $db->loadResult();

		if( !$result || !( $dbtotal_records >= 0 ) ) return;
		
		$totals = array();
		
		$totals[0]['value'] = $dbtotal_records.' <i>'.JText::_( 'record(s)').'</i>' ;
		$totals[0]['text'] =  JText::_( 'Total in DB' );

		$totals[1]['value'] = $result.' <i>'.JText::_( 'current record(s)').'</i>' ;
		$totals[1]['text'] = round($result / ($dbtotal_records/100), 1).'%</b></big> '.JText::_( 'of all records ' );

		$totals[2]['value'] = $total.' <i><b>'.JText::_( 'category(s)' ).'</b></i>';
		$totals[2]['text'] = JText::_('total in DB');

		$totals[3]['value'] = count($category).' <i><b>'.JText::_( 'current category(s)' ).'</b></i>';
		$totals[3]['text'] = round(count($category) * 100 / $total, 1).'% '.JText::_('of all categories');

		return $totals;
	}
	
	function incrementDate( $date, $unit )
	{
		$eDate = getDate( strtotime( $date ) );

		switch ( $unit ) {
			case "sday":
				$eDate["mday"] ++;
				break;
			case "sweek":
				$eDate["mday"] += 7;
				break;
			case "smonth":
				$eDate["mon"] ++;
				break;
			case "syear":
				$eDate["year"] ++;
				break;
		}

		return  date( 'Y-m-d', mktime( $eDate["hours"], $eDate["minutes"], $eDate["seconds"], $eDate["mon"], $eDate["mday"], $eDate["year"] ) );
	}
}
?>